<?php

namespace Drupal\report_station\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;

/**
 * Report list builder attribute for plugin discovery.
 *
 * List builders build the render arrays which display the report entry lists
 * for report stations or other content that wants to render reports.
 *
 * @see \Drupal\report_station\Plugin\ReportListBuilderManager
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class ReportStationListBuilder extends Plugin {

  /**
   * Creates a new instance of the ReportStationReceiver plugin attribute.
   *
   * @param string $id
   *   The plugin identifier.
   * @param \Stringable|string $label
   *   The receiver plugin label.
   * @param class-string|null $deriver
   *   The plugin deriver object class.
   */
  public function __construct(
    public readonly string $id,
    public readonly \Stringable|string $label,
    public readonly ?string $deriver = NULL,
  ) {}

}
