<?php

namespace Drupal\report_station\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;

/**
 * Report station transmission receiver attribute for plugin discovery.
 *
 * @see \Drupal\report_station\Plugin\ReportReceiverPluginManager
 * @see \Drupal\report_station\Plugin\ReportReceiverPluginManagerInterface
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class ReportStationReceiver extends Plugin {

  /**
   * Creates a new instance of the ReportStationReceiver plugin attribute.
   *
   * @param string $id
   *   The plugin identifier.
   * @param \Stringable|string $label
   *   The receiver plugin label.
   * @param \Stringable|string|null $description
   *   The receiver plugin description.
   * @param class-string|null $deriver
   *   The plugin deriver object class.
   */
  public function __construct(
    public readonly string $id,
    public readonly \Stringable|string $label,
    public readonly \Stringable|string|null $description = NULL,
    public readonly ?string $deriver = NULL,
  ) {}

}
