<?php

namespace Drupal\report_station\Entity\Access;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Access\AccessResultInterface;
use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * Report station entity access control handler.
 */
class ReportStationAccessControl extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  public function access(EntityInterface $entity, $operation, ?AccountInterface $account = NULL, $return_as_object = FALSE): bool|AccessResultInterface {
    /** @var \Drupal\report_station\Entity\ReportStationInterface $entity */
    if ('receive_transmission' === $operation) {
      $accessResult = $entity->isPublished() ? AccessResult::allowed() : AccessResult::forbidden();
      return $return_as_object ? $accessResult : $accessResult->isAllowed();
    }

    return parent::access($entity, $operation, $account, $return_as_object);
  }

}
