<?php

namespace Drupal\report_station\Entity\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Report station default edit entity form.
 */
class ReportStationForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function form(array $form, FormStateInterface $form_state): array {
    $form = parent::form($form, $form_state);

    $form['advanced'] = [
      '#type' => 'vertical_tabs',
      '#weight' => 50,
    ];

    $form['author'] = [
      '#type' => 'details',
      '#title' => $this->t('Authoring Information'),
      '#group' => 'advanced',
      '#optional' => TRUE,
      '#access' => $form['uid']['#access'] ?? NULL,
    ];
    $form['uid']['#group'] = 'author';

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state): int {
    $status = parent::save($form, $form_state);

    /** @var \Drupal\report_station\Entity\ReportStationInterface $entity */
    $entity = $this->getEntity();
    $msgParams = ['%label' => $entity->label()];

    $msg = SAVED_NEW === $status
      ? $this->t('Created the %label.', $msgParams)
      : $this->t('Saved the %label.', $msgParams);

    $this->messenger()->addStatus($msg);
    $form_state->setRedirectUrl($entity->toUrl('collection'));

    return $status;
  }

}
