<?php

namespace Drupal\report_station\Entity\Storage;

use Drupal\Core\Entity\ContentEntityTypeInterface;
use Drupal\Core\Entity\Sql\SqlContentEntityStorageSchema;

/**
 * Entity handler for report entry entity storage schemas.
 */
class ReportEntryStorageSchema extends SqlContentEntityStorageSchema {

  /**
   * {@inheritdoc}
   */
  protected function initializeBaseTable(ContentEntityTypeInterface $entity_type): array {
    $schema = parent::initializeBaseTable($entity_type);

    // Create indexes to sort reported by created, and by environments.
    $schema['indexes']['created'] = ['created'];
    $schema['indexes']['report'] = [
      'name',
      'environment',
      'created',
    ];

    return $schema;
  }

}
