<?php

namespace Drupal\report_station\Entity\Storage;

use Drupal\Core\Entity\ContentEntityTypeInterface;
use Drupal\Core\Entity\Sql\SqlContentEntityStorageSchema;

/**
 * Entity handler for report station entity storage schemas.
 */
class ReportStationStorageSchema extends SqlContentEntityStorageSchema {

  /**
   * {@inheritdoc}
   */
  protected function initializeBaseTable(ContentEntityTypeInterface $entity_type): array {
    $schema = parent::initializeBaseTable($entity_type);

    // Ensure that names are unique and indexed for fast retrieval.
    $schema['unique keys']['name'] = ['name'];

    return $schema;
  }

}
