<?php

namespace Drupal\report_station\Exception;

use Drupal\report_station\Plugin\ReportReceiverInterface;

/**
 * Exception to throw when a transmission signature fails verification.
 */
class SignatureVerifyException extends TransmissionException {

  /**
   * Create a new instance of a TransmissionException instance.
   *
   * @param \Drupal\report_station\Plugin\ReportReceiverInterface $receiver
   *   The receiver that encountered the signature error.
   * @param int $code
   *   An error code integer.
   * @param \Throwable|null $prev
   *   Previous exception if using exception chaining.
   */
  public function __construct(ReportReceiverInterface $receiver, int $code = 0, ?\Throwable $prev = NULL) {
    $message = sprintf('Failed to verify signature for "%s" receiver for %s',
      $receiver->getPluginId(),
      $receiver->getStationName(),
    );

    parent::__construct($message, $code, $prev);
  }

}
