<?php

namespace Drupal\report_station\Exception;

/**
 * General error with transmitting and receiving report transmissions.
 */
class TransmissionException extends \Exception {

  /**
   * Create a new instance of a TransmissionException instance.
   *
   * @param string|null $message
   *   Exception message, defaults to a generic transmission error.
   * @param int $code
   *   An error code integer.
   * @param \Throwable|null $prev
   *   Previous exception if using exception chaining.
   */
  public function __construct(?string $message = NULL, int $code = 0, ?\Throwable $prev = NULL) {
    parent::__construct(
      $message ?? 'Failed to transmit report due to transmission protocol error.',
      $code,
      $prev
    );
  }

}
