<?php

namespace Drupal\report_station\Plugin;

use Drupal\Component\Plugin\ConfigurableInterface;
use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\report_station\Entity\ReportStationInterface;

/**
 * Default report list builder which generates table of report summaries.
 */
interface ReportListBuilderInterface extends PluginInspectionInterface, ConfigurableInterface {

  /**
   * Builds a display of a list of reports for a report station.
   *
   * @param \Drupal\report_station\Entity\ReportStationInterface $station
   *   The report station entity to render report list for.
   * @param string|null $environment
   *   An environment filter if the list should be filtered by environment.
   *
   * @return array
   *   A renderable array for displaying the list of reports.
   */
  public function buildList(ReportStationInterface $station, ?string $environment = NULL): array;

}
