<?php

namespace Drupal\report_station\Plugin;

use Drupal\report_station\Entity\ReportStationInterface;
use Drupal\server_beacon\Plugin\ConfigurablePluginBase;

/**
 * Base class to provide default method implementations for ReportReceivers.
 */
abstract class ReportReceiverBase extends ConfigurablePluginBase implements ReportReceiverInterface {

  /**
   * The owning report station.
   *
   * @var \Drupal\report_station\Entity\ReportStationInterface
   */
  protected ReportStationInterface $station;

  /**
   * {@inheritdoc}
   */
  public function getStationName(): string {
    return $this->station->getName();
  }

  /**
   * {@inheritdoc}
   */
  public function setReportStation(ReportStationInterface $reportStation): self {
    $this->station = $reportStation;
    return $this;
  }

}
