<?php

namespace Drupal\report_station\Plugin\ReportStation\Receiver;

use Drupal\Core\Form\FormStateInterface;
use Drupal\report_station\Plugin\ReportReceiverBase;
use Drupal\report_station\Plugin\ReportReceiverInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * NULL implementation for report receiver.
 *
 * Used as a fallback so report station groups can load if a plugin becomes
 * unavailable due to an extension being unavailable. This receiver shouldn't
 * ever be used directly.
 */
class None extends ReportReceiverBase implements ReportReceiverInterface {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration(): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function __invoke(Request $request): array {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    return $form;
  }

}
