<?php

namespace Drupal\report_station\Strategy;

use Drupal\toolshed\Strategy\StrategyInterface;

/**
 * Interface for beacon data render implementations.
 *
 * Renders server beacon data into full report content that show the full
 * reported data (can be thought of as a report data formatter).
 */
interface ReportRenderInterface extends StrategyInterface {

  /**
   * Format the report data into content items for theming.
   *
   * @param string $beaconType
   *   The plugin ID of the beacon that this data belongs to.
   * @param array $data
   *   The report data provided by a server beacon plugin.
   *
   * @return array
   *   Formatted summary items for a 'report_station_beacon' theme render array.
   */
  public function __invoke(string $beaconType, array $data): array;

}
